-- I based this GUI on the one used in the BadBoy anti-spam addon.
-- Consequently, I owe many thanks to Funkydude; permission was given to use his addon in this way.
-- Get BadBoy Anti-Spam here: https://mods.curse.com/addons/wow/bad-boy

local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function OptionsFrame_OnLoad()

SlashCmdList["DROPTIONS"] = droptions_command
	SLASH_DROPTIONS1 = "/dr"
	
StaticPopupDialogs["RESET_STATS"] = {
  text = L["Reset Statistics"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetstats()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

StaticPopupDialogs["RESET_VARIABLES"] = {
  text = L["Reset SavedVariables"] .. "\n\n" .. L["Are you sure?"],
  button1 = L["Yes"],
  button2 = L["No"],
  OnAccept = function()
      resetvariables()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}
end

function resetvariables()

DRConfig = {
	["DeclineDuel"] = 'ON',
	["ShowChatMessage"] = 'ON',
	["ShowLoadMessage"] = 'ON',
	["DeclinePB"] = 'OFF',
	["OptionsWindow"] = 'HIDDEN',
	["AntiLag"] = 'OFF',
	["MaxLatency"] = '250',
	["FPSCheck"] = 'OFF',
	["MinFPS"] = '15',
	["DeclineEnemy"] = 'OFF',
	["OptionsVis"] = '0.9'
}

DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Settings returned to default values."])

end

function resetstats()
	GlobalDC = 0
	DuelsDeclined = 0
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Your statistics have been reset."])
end

function droptions_command(msg, editbox)

if msg == "" or msg == nil then

if DRConfig.OptionsWindow == "VISIBLE" then
	return
elseif DRConfig.OptionsWindow == "HIDDEN" then
	DRConfig.OptionsWindow = 'VISIBLE'
	
local droptions = CreateFrame("Frame", "DRConfig", UIParent)
droptions:SetSize(500, 400) -- WxH
droptions:SetPoint("CENTER")
droptions:SetClampedToScreen(true)
droptions:EnableMouse(true)
droptions:SetMovable(true)
droptions:RegisterForDrag("LeftButton")
droptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
droptions:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
droptions:Show()
local bg = droptions:CreateTexture()
bg:SetAllPoints(droptions)
bg:SetColorTexture(0, 0, 0, tonumber(DRConfig.OptionsVis))
local close = CreateFrame("Button", nil, droptions, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", droptions, "TOPRIGHT", -5, -5)

droptions:SetScript("OnHide", function(frame)
	DRConfig.OptionsWindow = 'HIDDEN'
	
	local transparency = tonumber(DRConfig.OptionsVis)
	
	if transparency < 0 or transparency > 1 then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r |cFFFF0000[" .. L["Error"] .. "]|r " .. L["Transparency must be between 0 and 1."])
		DRConfig.OptionsVis = '0.9'
	end
end)

-- Name and Version

local title = droptions:CreateFontString(nil, nil, "GameFontNormalLarge")
title:SetPoint("TOPLEFT", 16, -16)
title:SetText("|cFF00FFFF" .. L["DuelResponse"] .." v" .. GetAddOnMetadata("DuelResponse", "Version") .. "|r")

-- CATEGORY: ANTI-DUEL

local lblCatBlockSettings = droptions:CreateFontString(nil, nil, "GameFontHighlight")
lblCatBlockSettings:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -16)
lblCatBlockSettings:SetText("|cFFFFFFFF" .. L["Block Settings"] .. "|r")

-- Decline Duel Checkbox

local chkDeclineDuel = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkDeclineDuel:SetPoint("TOPLEFT", lblCatBlockSettings, "BOTTOMLEFT", 0, -8)

	if DRConfig.DeclineDuel == "ON" then
		chkDeclineDuel:SetChecked(true)
	elseif DRConfig.DeclineDuel == "OFF" then
		chkDeclineDuel:SetChecked(false)
	end

chkDeclineDuel:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRConfig.DeclineDuel = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will not be declined."])
	elseif tick == true then
		DRConfig.DeclineDuel = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will be declined."])
	end
end)

chkDeclineDuel:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Hold down Ctrl or Alt to let a request through."], 1, 1, 1)
	GameTooltip:Show()
end)

local chkDeclineDuelText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkDeclineDuelText:SetPoint("LEFT", chkDeclineDuel, "RIGHT", 0, 1)
chkDeclineDuelText:SetText("|cFFEFC502" .. L["Block all incoming duel requests"] .. "|r")

-- Pet Battle Checkbox

local chkDeclinePetBattle = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkDeclinePetBattle:SetPoint("TOPLEFT", chkDeclineDuel, "BOTTOMLEFT")

	if DRConfig.DeclinePB == "ON" then
		chkDeclinePetBattle:SetChecked(true)
	elseif DRConfig.DeclinePB == "OFF" then
		chkDeclinePetBattle:SetChecked(false)
	end

chkDeclinePetBattle:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRConfig.DeclinePB = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Pet battle requests will not be declined."])
	elseif tick == true then
		DRConfig.DeclinePB = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Pet battle requests will be declined."])
	end
end)

chkDeclinePetBattle:SetScript("OnEnter", function(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP")
	GameTooltip:AddLine(L["Hold down Ctrl or Alt to let a request through."], 1, 1, 1)
	GameTooltip:Show()
end)

local chkDeclinePetBattleText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkDeclinePetBattleText:SetPoint("LEFT", chkDeclinePetBattle, "RIGHT", 0, 1)
chkDeclinePetBattleText:SetText("|cFFEFC502" .. L["Block all incoming pet battle requests"] .. "|r")

-- CATEGORY: DISPLAY

local lblCatDisplaySettings = droptions:CreateFontString(nil, nil, "GameFontHighlight")
lblCatDisplaySettings:SetPoint("TOPLEFT", chkDeclinePetBattle, "BOTTOMLEFT", 0, -8)
lblCatDisplaySettings:SetText("|cFFFFFFFF" .. L["Display Settings"] .. "|r")

-- Chat Message Checkbox

local chkShowChatMsg = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkShowChatMsg:SetPoint("TOPLEFT", lblCatDisplaySettings, "BOTTOMLEFT", 0, -8)

	if DRConfig.ShowChatMessage == "ON" then
		chkShowChatMsg:SetChecked(true)
	elseif DRConfig.ShowChatMessage == "OFF" then
		chkShowChatMsg:SetChecked(false)
	end

chkShowChatMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowChatMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat frame messages have been turned off."])
	elseif tick == true then
		DRConfig.ShowChatMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat frame messages have been turned on."])
	end
end)

local chkShowChatMsgText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkShowChatMsgText:SetPoint("LEFT", chkShowChatMsg, "RIGHT", 0, 1)
chkShowChatMsgText:SetText("|cFFEFC502" .. L["Chat frame message"] .. "|r")

-- Options Frame Visibility

local lblOptionsVis = droptions:CreateFontString(nil, nil, "GameFontHighlight")
lblOptionsVis:SetPoint("LEFT", chkShowChatMsgText, "RIGHT", 16, 0)
lblOptionsVis:SetText("|cFFEFC502" .. L["Window Transparency:"] .. "|r")

local txtTransparency = CreateFrame("EditBox", nil, droptions, "InputBoxTemplate")
txtTransparency:SetPoint("LEFT", lblOptionsVis, "RIGHT", 16, 0)
txtTransparency:SetAutoFocus(false)
txtTransparency:SetWidth(32)
txtTransparency:SetHeight(16)
txtTransparency:SetMaxLetters(4)
txtTransparency:IsNumeric(false)
txtTransparency:Show()

local text = DRConfig.OptionsVis
		txtTransparency:SetText(text)

txtTransparency:SetScript("OnLeave", GameTooltip_Hide)
txtTransparency:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRConfig.OptionsVis = text
end)

-- Load Message Checkbox

local chkShowLoadMsg = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkShowLoadMsg:SetPoint("TOPLEFT", chkShowChatMsg, "BOTTOMLEFT")

	if DRConfig.ShowLoadMessage == "ON" then
		chkShowLoadMsg:SetChecked(true)
	elseif DRConfig.ShowLoadMessage == "OFF" then
		chkShowLoadMsg:SetChecked(false)
	end

chkShowLoadMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowLoadMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Load message disabled."])
	elseif tick == true then
		DRConfig.ShowLoadMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Load message enabled."])
	end
end)

local chkShowLoadMsgText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkShowLoadMsgText:SetPoint("LEFT", chkShowLoadMsg, "RIGHT", 0, 1)
chkShowLoadMsgText:SetText("|cFFEFC502" .. L["Welcome message"] .. "|r")

-- CATEGORY: DUEL SETTINGS

local lblCatSystemSettings = droptions:CreateFontString(nil, nil, "GameFontHighlight")
lblCatSystemSettings:SetPoint("TOPLEFT", chkShowLoadMsg, "BOTTOMLEFT", 0, -8)
lblCatSystemSettings:SetText("|cFFFFFFFF" .. L["Duel Settings"] .. "|r")

-- Latency Editbox

local chkAntiLag = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkAntiLag:SetPoint("TOPLEFT", lblCatSystemSettings, "BOTTOMLEFT", 0, -8)

	if DRConfig.AntiLag == "ON" then
		chkAntiLag:SetChecked(true)
	elseif DRConfig.AntiLag == "OFF" then
		chkAntiLag:SetChecked(false)
	end

chkAntiLag:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.AntiLag = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Lag check disabled."])
	elseif tick == true then
		DRConfig.AntiLag = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Lag check enabled."])
	end
end)

local chkAntiLagText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkAntiLagText:SetPoint("LEFT", chkAntiLag, "RIGHT", 0, 1)
chkAntiLagText:SetText("|cFFEFC502" .. L["Decline duels when world latency is above"] .. "|r")

local txtLatency = CreateFrame("EditBox", nil, droptions, "InputBoxTemplate")
txtLatency:SetPoint("LEFT", chkAntiLagText, "RIGHT", 16, 0)
txtLatency:SetAutoFocus(false)
txtLatency:SetWidth(32)
txtLatency:SetHeight(16)
txtLatency:SetMaxLetters(3)
txtLatency:IsNumeric(true)
txtLatency:Show()

local text = DRConfig.MaxLatency
		txtLatency:SetText(text)

txtLatency:SetScript("OnLeave", GameTooltip_Hide)
txtLatency:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRConfig.MaxLatency = text
end)

local lblmillisec = droptions:CreateFontString(nil, nil, "GameFontHighlight")
	lblmillisec:SetPoint("LEFT", txtLatency, "RIGHT", 16, 1)
	lblmillisec:SetText("|cFFEFC502ms|r")
	
-- FPS Editbox

local chkMinFPS = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkMinFPS:SetPoint("TOPLEFT", chkAntiLag, "BOTTOMLEFT")

	if DRConfig.FPSCheck == "ON" then
		chkMinFPS:SetChecked(true)
	elseif DRConfig.FPSCheck == "OFF" then
		chkMinFPS:SetChecked(false)
	end

chkMinFPS:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.FPSCheck = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Framerate check disabled.."])
	elseif tick == true then
		DRConfig.FPSCheck = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Framerate check enabled."])
	end
end)

local chkMinFPSText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkMinFPSText:SetPoint("LEFT", chkMinFPS, "RIGHT", 0, 1)
chkMinFPSText:SetText("|cFFEFC502" .. L["Decline duels when your framerate drops below"] .. "|r")

local txtMinFPS = CreateFrame("EditBox", nil, droptions, "InputBoxTemplate")
txtMinFPS:SetPoint("LEFT", chkMinFPSText, "RIGHT", 16, 0)
txtMinFPS:SetAutoFocus(false)
txtMinFPS:SetWidth(32)
txtMinFPS:SetHeight(16)
txtMinFPS:SetMaxLetters(3)
txtMinFPS:IsNumeric(true)
txtMinFPS:Show()

local text = DRConfig.MinFPS
		txtMinFPS:SetText(text)

txtMinFPS:SetScript("OnLeave", GameTooltip_Hide)
txtMinFPS:SetScript("OnHide", function(frame)
	local text = frame:GetText()
	DRConfig.MinFPS = text
end)

local lblFPS = droptions:CreateFontString(nil, nil, "GameFontHighlight")
lblFPS:SetPoint("LEFT", txtMinFPS, "RIGHT", 16, 1)
lblFPS:SetText("|cFFEFC502FPS|r")

-- Enemy Players Checkbox

local chkEnemyPlayers = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
chkEnemyPlayers:SetPoint("TOPLEFT", chkMinFPS, "BOTTOMLEFT")

	if DRConfig.DeclineEnemy == "ON" then
		chkEnemyPlayers:SetChecked(true)
	elseif DRConfig.DeclineEnemy == "OFF" then
		chkEnemyPlayers:SetChecked(false)
	end

chkEnemyPlayers:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.DeclineEnemy = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duels from enemy players will not be declined."])
	elseif tick == true then
		DRConfig.DeclineEnemy = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duels from enemy players will be declined."])
	end
end)

local chkEnemyPlayersText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
chkEnemyPlayersText:SetPoint("LEFT", chkEnemyPlayers, "RIGHT", 0, 1)
chkEnemyPlayersText:SetText("|cFFEFC502" .. L["Decline duels from enemy players"] .. "|r")
	
-- Status Text

local statsTitle = droptions:CreateFontString("DROptionsConfigTitle", nil, "GameFontHighlight")
statsTitle:SetPoint("TOPLEFT", chkEnemyPlayers, "BOTTOMLEFT", 0, -16)
statsTitle:SetText(L["Total duels blocked: "] .. tonumber(GlobalDC) .. " (" ..  UnitName("player") .. ": " .. tonumber(DuelsDeclined) .. ")")

-- Reset Stats Button

local btnResetStats = CreateFrame("Button", nil, droptions, "UIPanelButtonTemplate")
btnResetStats:SetSize(200,25)
btnResetStats:SetPoint("TOPLEFT", statsTitle, "BOTTOMLEFT", 0, -8)
btnResetStats:SetScript("OnClick", function(frame)
	StaticPopup_Show("RESET_STATS")
end)
btnResetStats:SetText(L["Reset Statistics"])

-- Save on close text

local lblSaveOnClose = droptions:CreateFontString(nil, nil, "GameFontHighlight")
lblSaveOnClose:SetPoint("TOPLEFT", btnResetStats, "BOTTOMLEFT", 0, -8)
lblSaveOnClose:SetText(L["Settings will be applied once this window is closed."])
	
end

elseif msg == "reset" then

StaticPopup_Show("RESET_VARIABLES")

end

end